<?php

namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\TipoManutencaoService;

class TipoManutencaoController extends FMCrud{
    protected $dataSourceName = 'fcm_checklistagend';
    protected $TipoManutencaoService;

    public function __construct($crudService, $environment, TipoManutencaoService $TipoManutencaoService) {
        parent::__construct($crudService, $environment);
        $this->TipoManutencaoService = $TipoManutencaoService;
    }

    public function rotaBase(DTO\Request $request, DTO\Response $response) {
        $method = $request->getMethod();
        $parametros = $request->getParameters();
        $tipoManut = '';

        if ($method== "POST") {
            $tipoManut = $this->TipoManutencaoService->inserirTipoManutencao($parametros);

        } else if ($method == "GET") {
           $tipoManut = $this->TipoManutencaoService->getInformacoesTipoManutencao();
        }

        $dtsVal = new DataSet('tipoManut', [$tipoManut]);
        $response->addDataSet($dtsVal);
    }
}

?>