<?php
namespace FM\Factory;

use Doctrine\ORM\EntityManager;

class NovoChecklistFactory {
    
    protected $connection;
    
    public function __construct(EntityManager $entityManager) {
        
        $this->connection = $entityManager->getConnection();
    }

    public function buscaNomeLocais() {
        
        $sql = "SELECT NRTIPOLOCALCLI, NMTIPOLOCALCLI
                  FROM FCM_TIPOLOCALCLI
                 WHERE IDTIPOLOCALCLI = 3";
        
        $std = $this->connection->prepare($sql);
        
        //Talvez depois testa comentar essa linha caso de erro
        $std->execute();
        return $std->fetchAll();
    }

    public function filtroTags() {
        
        $sql = "SELECT FCM_TAREFA.NRTAREFA, FCM_TAREFA.NMTAREFA, FCM_TAREFA.NRATIVIDADE
                      FROM FCM_TAREFA
                      join FCM_ATIVIDADE
                        ON FCM_TAREFA.NRATIVIDADE = FCM_ATIVIDADE.NRATIVIDADE";
        $std = $this->connection->prepare($sql);

        $std->execute();
        return $std->fetchAll();
    }
    
    public function buscaGrupoTags ($tarefas) {
       $sql = "SELECT DISTINCT DSTAGSTAREFA 
          FROM FCM_TAGSTAREFA
         WHERE NRTAREFA IN (".$tarefas.") ";
         
        $std = $this->connection->prepare($sql);

        $std->execute();
        return $std->fetchAll();
    }
    
    public function filtroItens() {
        
        $sql = "SELECT NRATIVIDADE, NMATIVIDADE
                  FROM FCM_ATIVIDADE";
        
        $std = $this->connection->prepare($sql);

        $std->execute();
        return $std->fetchAll();
    }
    // busca todas as tarefas de cadas atividade
    public function buscaTarefas($parametroAtividade){
        $sql = "SELECT NRTAREFA, NMTAREFA, DSPOPSERVICO
                  FROM FCM_TAREFA
                 WHERE NRATIVIDADE = :NRATIVIDADE";
                 
        $std = $this->connection->prepare($sql);

        $std->execute($parametroAtividade);
        return $std->fetchAll();
    }
    // busca os dados de Critérios de não conformidades conforme a tarefa
    public function buscaCriterioAtividades($parametroTarefa){
        $sql = "SELECT NRCRITERIOTAREFA, DSCRITERIOTAREFA, NRTAREFA
          FROM FCM_CRITERIOTAREFA
         WHERE NRTAREFA = :NRTAREFA";
                 
        $std = $this->connection->prepare($sql);

        $std->execute($parametroTarefa);
        return $std->fetchAll();
    }
    // Busca as Tags conforme o parametro passado da Tarefa
    public function buscaTagsAtividades($parametroTarefa){
        $sql = "SELECT NRTAGSTAREFA,NRTAREFA,NRESCOPOSTAREFA
          FROM FCM_TAGSTAREFA
         WHERE NRTAREFA = :NRTAREFA";
                 
        $std = $this->connection->prepare($sql);

        $std->execute($parametroTarefa);
        return $std->fetchAll();
    }
    
    public function buscaDadosCardAtividades() {
        
        $sql = "SELECT FCM_TIPOLOCALCLI.NRTIPOLOCALCLI, FCM_TIPOLOCALCLI.NMTIPOLOCALCLI, FCM_TAREFACHK.NRTAREFACHK, FCM_TAREFACHK.NMTAREFACHK
                  FROM FCM_TIPOLOCALCLI, FCM_TAREFACHK";
                  
        $std = $this->connection->prepare($sql);
        
        $std->execute();
        return $std->fetchAll();
    }
    
    //busca o título do card Atividades e Critérios
    public function buscaDadosAtividadeseCriterios($params) {
        $sql = "SELECT FCM_ATIVIDADE.NRATIVIDADE, FCM_ATIVIDADE.NMATIVIDADE, FCM_ATIVIDADE.DSCORIDATIVIDADE
                  FROM FCM_ATIVIDADE".$params." ORDER BY NMATIVIDADE";

        $std = $this->connection->prepare($sql);
        
        $std->execute();
        
        return $std->fetchAll();
    }
    
    //REQUISÇÃO DOS DADOS PARA MONTAR OS CARDS NA TELA DE LOCAIS
    public function buscaNomeLocal($params) {
        
        $sql = "SELECT FCM_CHECKlIST.NMCHECKLIST, NVL(FCM_TIPOLOCALCLI.DSICONETIPOLOCAL,' ') AS DSICONETIPOLOCAL, FCM_TIPOLOCALCLI.NMTIPOLOCALCLI,
                NVL(FCM_CHECKlIST.DSCHECKLIST,' ') AS DSCHECKLIST, FCM_CHECKLIST.NRCHECKLIST
                   FROM FCM_CHECKLIST
                   LEFT JOIN FCM_TIPOLOCALCLI
                   ON FCM_TIPOLOCALCLI.NRTIPOLOCALCLI = FCM_CHECKLIST. NRTIPOLOCALCLI".$params;

        $std = $this->connection->prepare($sql);
        $std->execute();
        return $std->fetchAll();
    }
    
    //fazer tres funções para cada insert, falta informacoes das colunas ainda até NRORG
    
    //insere nova atividade
    public function insertNovaAtividadeBase($parametrosAtividades) {
    $sql = " INSERT INTO FCM_ATIVIDADECHK (NRATIVIDADECHK, NRATIVIDADE, NRCHECKLIST, IDATIVO)
    VALUES (:NRATIVIDADECHK, :NRATIVIDADE, :NRCHECKLIST, 'S')";

    $std = $this->connection->prepare($sql);
    
    $std->execute($parametrosAtividades);
    
    }
    
    public function insertNovaTarefaBase($parametrosTarefas) {
    
    $sql = " INSERT INTO FCM_TAREFACHK (NRTAREFACHK, NRTAREFA, NRCHECKLIST, NRATIVIDADECHK, IDATIVO)
    VALUES (:NRTAREFACHK, :NRTAREFA, :NRCHECKLIST, :NRATIVIDADECHK, 'S')";

    $std = $this->connection->prepare($sql);
    
    $std->execute($parametrosTarefas);
    
    }
    
    public function insertNovoCriterioBase($parametrosCriterio) {
    
    $sql = " INSERT INTO FCM_CRITERIOTAREFACHK (NRCRITERIOTAREFACHK, NRCRITERIOTAREFA, NRTAREFACHK, IDATIVO)
    VALUES (:NRCRITERIOTAREFACHK, :NRCRITERIOTAREFA, :NRTAREFACHK, 'S')";

    $std = $this->connection->prepare($sql);
    
    $std->execute($parametrosCriterio);
    
    }
    
    public function insertNovoTagBase($parametrosTags) {
    
    $sql = " INSERT INTO FCM_TAGSCHKTAREFA (NRTAGSCHKTAREFA, NRTAGSTAREFA, NRTAREFACHK, IDATIVO)
    VALUES (:NRTAGSCHKTAREFA, :NRTAGSTAREFA, :NRTAREFACHK, 'S')";

    $std = $this->connection->prepare($sql);
    
    $std->execute($parametrosTags);
    
    }
    
    public function insertRelacLocalChk($parametrosRelac) {
    $sql = "INSERT INTO FCM_RELACLOCALCHK(NRRELACLOCALCHK, NRLOCALCLIENTE, NRCHECKLIST, IDCHECKLISTPADRAO, IDATIVO)
     VALUES (:NRRELACLOCALCHK, :NRLOCALCLIENTE, :NRCHECKLIST, :IDCHECKLISTPADRAO, 'S' )";

    $std = $this->connection->prepare($sql);
    
    $std->execute($parametrosRelac);
    }
    
    public function insertNovoChecklistBase($parametroNovoChecklist) {
        $sql = "INSERT INTO  FCM_CHECKLIST (NRCHECKLIST, NMCHECKLIST, DSCHECKLIST, NRSETOR, NRCRITICIDADECHK, NRHABILIDADE, NRTIPOLOCALCLI, IDATIVO)
        VALUES (:NRCHECKLIST, :NMCHECKLIST, :DSCHECKLIST, :NRSETOR, :NRCRITICIDADECHK, :NRHABILIDADE, :NRTIPOLOCALCLI, 'S')";
        $std =  $this->connection->prepare($sql);
        $std->execute($parametroNovoChecklist);
    }
    
    public function buscaDadosCriteriosNaoConformidades($parametro){
        $sql = "SELECT FCM_TAGSTAREFA.NRTAGSTAREFA, FCM_TAGSTAREFA.DSTAGSTAREFA, FCM_CRITERIOTAREFA.NRCRITERIOTAREFA, 
                       FCM_CRITERIOTAREFA.DSCRITERIOTAREFA, FCM_TAREFA.NRTAREFA, FCM_TAREFA.NMTAREFA, 
                       FCM_ATIVIDADE.NRATIVIDADE, FCM_ATIVIDADE.NMATIVIDADE
                  FROM FCM_TAGSTAREFA
                  LEFT JOIN FCM_CRITERIOTAREFA
                    ON FCM_CRITERIOTAREFA.NRTAREFA = FCM_TAGSTAREFA.NRTAREFA
                  JOIN FCM_TAREFA
                    ON FCM_TAREFA.NRTAREFA = FCM_TAGSTAREFA.NRTAREFA
                  JOIN FCM_ATIVIDADE
                    ON FCM_ATIVIDADE.NRATIVIDADE = FCM_TAREFA.NRATIVIDADE
                 WHERE FCM_TAREFA.NRTAREFA IN (".$parametro['NRTAREFA'].")
                   AND FCM_TAGSTAREFA.DSTAGSTAREFA = '".$parametro['DSTAGSTAREFA']."'
                  GROUP BY FCM_TAGSTAREFA.NRTAGSTAREFA, FCM_TAGSTAREFA.DSTAGSTAREFA, FCM_CRITERIOTAREFA.NRCRITERIOTAREFA, 
                       FCM_CRITERIOTAREFA.DSCRITERIOTAREFA, FCM_TAREFA.NRTAREFA, FCM_TAREFA.NMTAREFA, 
                       FCM_ATIVIDADE.NRATIVIDADE, FCM_ATIVIDADE.NMATIVIDADE
                  ORDER BY FCM_ATIVIDADE.NRATIVIDADE,  FCM_TAREFA.NRTAREFA, FCM_TAGSTAREFA.NRTAGSTAREFA, FCM_CRITERIOTAREFA.NRCRITERIOTAREFA";
        
        $std = $this->connection->prepare($sql);

        $std->execute();
        return $std->fetchAll();
        
    }
    
    public function criaGruposTags($parametro) {
        $sql = "SELECT DISTINCT DSTAGSTAREFA 
                 FROM FCM_TAGSTAREFA
                 WHERE NRTAREFA IN (".$parametro.")";
        $std = $this->connection->prepare($sql);
    
        $std->execute();
        return $std->fetchAll();
    }
    
    public function getDadosEditCard($parametro){
        $sql = "SELECT NRCHECKLIST, NMCHECKLIST, DSCHECKLIST
                FROM FCM_CHECKLIST
                WHERE NRCHECKLIST= :NRCHECKLIST";
                
        $std = $this->connection->prepare($sql);
    
        $std->execute($parametro);
        return $std->fetchAll();
    }
    // retorna os tres itens(TipoLocal, Descricao e nome Checklist)
    
    public function getTipoLocal($parametro){
        $sql = "SELECT FCM_TIPOLOCALCLI.NMTIPOLOCALCLI,FCM_TIPOLOCALCLI.NRTIPOLOCALCLI, FCM_CHECKLIST.NRCHECKLIST, FCM_CHECKLIST.NMCHECKLIST, FCM_CHECKLIST.DSCHECKLIST
                FROM FCM_CHECKLIST
                LEFT JOIN FCM_TIPOLOCALCLI
                ON FCM_TIPOLOCALCLI.NRTIPOLOCALCLI = FCM_CHECKLIST.NRTIPOLOCALCLI
                WHERE FCM_CHECKLIST.NRCHECKLIST = :NRCHECKLIST";
        
        $std = $this->connection->prepare($sql);
    
        $std->execute($parametro);
        return $std->fetchAll();
    }
    // retorna os itens da tela de editar card local
    
    public function getItensEditCard($parametro){
        $sql = "SELECT FCM_ATIVIDADECHK.NRATIVIDADECHK, FCM_ATIVIDADECHK.NRATIVIDADE, FCM_ATIVIDADECHK.NRCHECKLIST, FCM_ATIVIDADE.NMATIVIDADE, FCM_ATIVIDADE.IDATIVO
                FROM FCM_ATIVIDADECHK
                JOIN FCM_ATIVIDADE
                ON FCM_ATIVIDADE.NRATIVIDADE = FCM_ATIVIDADECHK.NRATIVIDADE
                WHERE FCM_ATIVIDADECHK.NRCHECKLIST = :NRCHECKLIST";
                
        $std = $this->connection->prepare($sql);
    
        $std->execute($parametro);
        return $std->fetchAll();
        
    }
    // retorna as tarefas da tela de editar card local
    
    public function getTarefasEditCard($parametro){
        $sql = "SELECT FCM_TAREFACHK.NRTAREFACHK, FCM_TAREFACHK.NRTAREFA, FCM_TAREFA.NMTAREFA
                FROM FCM_TAREFACHK
                JOIN FCM_TAREFA
                ON FCM_TAREFA.NRTAREFA = FCM_TAREFACHK.NRTAREFA
                WHERE FCM_TAREFACHK.NRATIVIDADECHK = :NRATIVIDADECHK";
                
        $std = $this->connection->prepare($sql);
    
        $std->execute($parametro);
        return $std->fetchAll();
    }
    // retorna o grupo de tags da tela de editar card local
    
    public function getGrupoTagseditCard($parametro){
        $sql = "SELECT FCM_TAGSCHKTAREFA.NRTAGSCHKTAREFA, FCM_TAGSTAREFA.NRTAGSTAREFA, FCM_TAGSTAREFA.DSTAGSTAREFA
                FROM FCM_TAGSCHKTAREFA
                JOIN FCM_TAGSTAREFA
                ON FCM_TAGSTAREFA.NRTAGSTAREFA = FCM_TAGSCHKTAREFA.NRTAGSTAREFA
                WHERE FCM_TAGSCHKTAREFA.NRTAREFACHK = :NRTAREFACHK";
                
        $std = $this->connection->prepare($sql);
    
        $std->execute($parametro);
        return $std->fetchAll();
    }
    // retorna os criterios de não conformidades da tela de editar cards
    
    public function getCriterioEditCard($parametro){
        $sql = "SELECT FCM_CRITERIOTAREFACHK.NRCRITERIOTAREFACHK, FCM_CRITERIOTAREFA.NRCRITERIOTAREFA, FCM_CRITERIOTAREFA.DSCRITERIOTAREFA
                FROM FCM_CRITERIOTAREFACHK
                JOIN FCM_CRITERIOTAREFA
                ON FCM_CRITERIOTAREFA.NRCRITERIOTAREFA = FCM_CRITERIOTAREFACHK.NRCRITERIOTAREFA
                WHERE FCM_CRITERIOTAREFACHK.NRTAREFACHK = :NRTAREFACHK";
        
                $std = $this->connection->prepare($sql);
    
        $std->execute($parametro);
        return $std->fetchAll();
    }
    
    public function getRelacLocalChk($parametro) {
        $sql = "SELECT NRRELACLOCALCHK, NRLOCALCLIENTE, NRCHECKLIST, IDCHECKLISTPADRAO, IDATIVO 
                  FROM FCM_RELACLOCALCHK
                 WHERE NRCHECKLIST = :NRCHECKLIST";
        
        $std = $this->connection->prepare($sql);
    
        $std->execute($parametro);
        return $std->fetchAll();
    }
    
    public function getDadosCopiaCard($parametro){
        $sql = "SELECT NRCHECKLIST, NMCHECKLIST, DSCHECKLIST, NRSETOR, NRCRITICIDADECHK, NRHABILIDADE, IDATIVO, NRORG, DTINCLUSAO, CDOPERINCLUSAO, NRORGINCLUSAO, DTULTATU, CDOPERULTATU, NRORGULTATU, NRTIPOLOCALCLI
                FROM FCM_CHECKLIST
                WHERE NRCHECKLIST = :NRCHECKLIST";
        
        $std = $this->connection->prepare($sql);
    
        $std->execute($parametro);
        return $std->fetchAll();
    }
    
    // ----------------------------------------------------------//
    // Insere os dados da tela Modal( Atividades e Critérios)
    
    public function insertAtividade($parametro) {
        $sql = "INSERT INTO FCM_ATIVIDADE (NRATIVIDADE, NMATIVIDADE, DSICONEATIVIDADE, IDATIVO,DTINCLUSAO, DSCORIDATIVIDADE)
             VALUES (:NRATIVIDADE, :NMATIVIDADE, :DSICONEATIVIDADE, 'S', SYSDATE, :DSCORIDATIVIDADE)";

        $std = $this->connection->prepare($sql);

        $std->execute($parametro);
    }

    public function insertTarefa($parametro) {
        $sql = "INSERT INTO FCM_TAREFA (NRTAREFA, NMTAREFA, NRATIVIDADE,  DSPOPSERVICO, IDATIVO, DTINCLUSAO)
            VALUES (:NRTAREFA, :NMTAREFA, :NRATIVIDADE, :DSPOPSERVICO,'S', SYSDATE)";

        $std = $this->connection->prepare($sql);

        $std->execute($parametro);
    }

    public function insertCriterio($parametro) {
        $sql = "INSERT INTO FCM_CRITERIOTAREFA (NRCRITERIOTAREFA, DSCRITERIOTAREFA, NRTAREFA, IDTIPOCRITERIO, IDATIVO, DTINCLUSAO)
       VALUES (:NRCRITERIOTAREFA, :DSCRITERIOTAREFA, :NRTAREFA, :IDTIPOCRITERIO, 'S',SYSDATE)";

        $std = $this->connection->prepare($sql);

        $std->execute($parametro);
    }

    public function insertTag($parametro) {
        $sql = "INSERT INTO FCM_TAGSTAREFA (NRTAGSTAREFA, NRTAREFA, NRESCOPOSTAREFA, IDATIVO, DTINCLUSAO)
       VALUES  (:NRTAGSTAREFA, :NRTAREFA, :NRESCOPOSTAREFA, 'S',SYSDATE)";

        $std = $this->connection->prepare($sql);

        $std->execute($parametro);
    }

    //--------------------------------------------------------------//
    public function getTag($parametro) {
        
        $sql = "SELECT NRTAGSTAREFA
        FROM FCM_TAGSTAREFA
        WHERE NRTAREFA = :NRTAREFA
        AND DSTAGSTAREFA = :DSTAGSTAREFA";
        
        $std = $this->connection->prepare($sql);

        $std->execute($parametro);
        return $std->fetchAll();
    }
    
    public function validacaoChecklist($parametro) {
        $sql = "SELECT COUNT(*) AS VALIDA
                 FROM FCM_GERENCIAMENTOCHK
                 WHERE NRCHECKLIST = :NRCHECKLIST";
        $std = $this->connection->prepare($sql);
        
        $std->execute($parametro);
        return $std->fetchAll();
    }
    
    public function validacaoTarefa($parametro) {
        $sql = "SELECT COUNT(*) AS VALIDA
                 FROM FCM_TAREFACHK
                 WHERE NRTAREFA = :NRTAREFA";
                 
        $std = $this->connection->prepare($sql);
        
        $std->execute($parametro);
        return $std->fetchAll();
    }

    public function validacaoCriterio($variavel) {
        $sql = "SELECT COUNT(*) AS VALIDA
                FROM FCM_CRITERIOTAREFACHK
                WHERE NRCRITERIOTAREFA IN (".$variavel.") ";
        $std = $this->connection->prepare($sql);
        
        $std->execute();
        return $std->fetchAll();
    }

    public function validacaoTag($parametro) {
        $sql = "SELECT COUNT(*) AS VALIDA
                 FROM FCM_TAGSCHKTAREFA
                 WHERE NRTAGSTAREFA IN (".$parametro.") ";
        $std = $this->connection->prepare($sql);
        
        $std->execute();
        return $std->fetchAll();
    }
    
    public function updateChecklist($parametroNovoChecklist) {
        
        $sql = "UPDATE FCM_CHECKLIST 
                SET NMCHECKLIST = :NMCHECKLIST,
                DSCHECKLIST = :DSCHECKLIST
                WHERE NRCHECKLIST = :NRCHECKLIST";
                
        $std =  $this->connection->prepare($sql);
        $std->execute($parametroNovoChecklist);
    }
    //------------------------------------------------------//
    // Responsavel por deletar os itens inseridos quando é realizado o update
    public function deleteCriteriosChecklist($parametro) {
        $sql = " DELETE FROM FCM_CRITERIOTAREFACHK
                WHERE NRCRITERIOTAREFACHK = :NRCRITERIOTAREFACHK ";
        $std =  $this->connection->prepare($sql);
        $std->execute($parametro);
    }
    
    public function deleteTarefaChecklist($parametro) {
        $sql = " DELETE FROM FCM_TAREFACHK
                WHERE NRTAREFACHK = :NRTAREFACHK ";
        $std =  $this->connection->prepare($sql);
        $std->execute($parametro);
    }
    
    public function deleteAtividadeChecklist($parametro) {
        $sql = " DELETE FROM FCM_ATIVIDADECHK
                WHERE NRATIVIDADECHK = :NRATIVIDADECHK ";
        $std =  $this->connection->prepare($sql);
        $std->execute($parametro);
    }
    
    public function deleteTagsChecklist($parametro) {
        $sql = " DELETE FROM FCM_TAGSCHKTAREFA
                WHERE NRTAGSCHKTAREFA = :NRTAGSCHKTAREFA ";
        $std =  $this->connection->prepare($sql);
        $std->execute($parametro);
    }
    //---------------------------------------------------//
    // Responsavel por deletar as tarefas da tela de Atividades e Critérios
    public function deletaTarefa($parametro) {
        $sql = "DELETE FROM FCM_TAREFA
                WHERE NRTAREFA = :NRTAREFA";
        $std = $this->connection->prepare($sql);
        $std->execute($parametro);
    }
    
    public function deletaCriterio($parametro) {
        $sql = "DELETE FROM FCM_CRITERIOTAREFA
                WHERE NRCRITERIOTAREFA = :NRCRITERIOTAREFA";
        $std = $this->connection->prepare($sql);
        $std->execute($parametro);

    }
    
    public function deletaTag($parametro) {
        $sql = " DELETE FROM FCM_TAGSTAREFA
                WHERE NRTAGSTAREFA = :NRTAGSTAREFA";
        $std = $this->connection->prepare($sql);
        $std->execute($parametro);
    }

    public function deletaAtividade($parametro) {
        $sql = " DELETE FROM FCM_ATIVIDADE
                WHERE NRATIVIDADE = :NRATIVIDADE";
        $std = $this->connection->prepare($sql);
        $std->execute($parametro);
    }
    
    public function deleteChecklist($parametro) {
        $sql = " DELETE FROM FCM_CHECKLIST
                WHERE NRCHECKLIST = :NRCHECKLIST";
        $std = $this->connection->prepare($sql);
        $std->execute($parametro);
    }
        
    public function getRelac($parametro) {
        $sql = "SELECT FCM_RELCRITERIOTAGTAREFACHK.RELCRITERIOTAGTAREFACHK, FCM_RELCRITERIOTAGTAREFACHK.NRCRITERIOTAREFACHK, FCM_RELCRITERIOTAGTAREFACHK.NRTAGSCHKTAREFA, FCM_RELCRITERIOTAGTAREFACHK.NRTAREFACHK,
                FCM_CRITERIOTAREFACHK.NRCRITERIOTAREFA
                FROM FCM_RELCRITERIOTAGTAREFACHK
                JOIN FCM_CRITERIOTAREFACHK
                ON FCM_CRITERIOTAREFACHK.NRCRITERIOTAREFACHK = FCM_RELCRITERIOTAGTAREFACHK.NRCRITERIOTAREFACHK
                WHERE FCM_RELCRITERIOTAGTAREFACHK.NRTAREFACHK = :NRTAREFACHK";
        
                $std = $this->connection->prepare($sql);
    
        $std->execute($parametro);
        return $std->fetchAll();
    }
    
    
    public function insertRelacCritTag($parametro){
        $sql = "INSERT INTO FCM_RELCRITERIOTAGTAREFACHK (RELCRITERIOTAGTAREFACHK, NRCRITERIOTAREFACHK, NRTAGSCHKTAREFA, NRTAREFACHK, IDATIVO, DTINCLUSAO)
                VALUES (:RELCRITERIOTAGTAREFACHK, :NRCRITERIOTAREFACHK, :NRTAGSCHKTAREFA, :NRTAREFACHK, 'S',SYSDATE)";

        $std = $this->connection->prepare($sql);

        $std->execute($parametro);
    }
    
    public function deleteRelCriTag($parametro)  {
        $sql = "DELETE FROM FCM_RELCRITERIOTAGTAREFACHK
                WHERE NRTAREFACHK = :NRTAREFACHK";
        $std = $this->connection->prepare($sql);
        $std->execute($parametro);
    }
    
    
    public function updateRelCriterio($parametro) {
        $sql = "UPDATE FCM_RELCRITERIOTAGTAREFACHK
                SET NRCRITERIOTAREFACHK = :NRCRITERIOTAREFACHK
                WHERE NRTAREFACHK = :NRTAREFACHK
                AND NRCRITERIOTAREFACHK = :NRCRITERIOTAREFACHKOLD";
        $std = $this->connection->prepare($sql);
        $std->execute($parametro); 
    }
    
    public function updateRelTag($parametro) {
        $sql = "UPDATE FCM_RELCRITERIOTAGTAREFACHK
                SET NRTAGSCHKTAREFA = :NRTAGSCHKTAREFA
                WHERE NRTAREFACHK = :NRTAREFACHK
                AND NRTAGSCHKTAREFA = :NRTAGSCHKTAREFAOLD";
        $std = $this->connection->prepare($sql);
        $std->execute($parametro); 
    }
    
    public function changeColorActivity($param) {
        $sql = "UPDATE FCM_ATIVIDADE 
                SET DSCORIDATIVIDADE = '".$param['DSCORIDATIVIDADE']."'
                WHERE NRATIVIDADE = ".$param['NRATIVIDADE'];
        
        
        $std =  $this->connection->prepare($sql);
        
        $std->execute();
    }

    public function tagsCompleta($parametro) {
        $sql = "SELECT FCM_TAGSTAREFA.NRTAGSTAREFA, NVL(FCM_TAGSTAREFA.DSTAGSTAREFA, ' ') AS DSTAGSTAREFA, FCM_TAREFA.NRTAREFA, FCM_CRITERIOTAREFA.NRCRITERIOTAREFA, 
                       FCM_CRITERIOTAREFA.DSCRITERIOTAREFA, FCM_TAREFA.NRTAREFA, FCM_TAREFA.NMTAREFA, 
                       FCM_ATIVIDADE.NRATIVIDADE, FCM_ATIVIDADE.NMATIVIDADE
                  FROM FCM_TAGSTAREFA
                  LEFT JOIN FCM_CRITERIOTAREFA
                    ON FCM_CRITERIOTAREFA.NRTAREFA = FCM_TAGSTAREFA.NRTAREFA
                  JOIN FCM_TAREFA
                    ON FCM_TAREFA.NRTAREFA = FCM_TAGSTAREFA.NRTAREFA
                  JOIN FCM_ATIVIDADE
                    ON FCM_ATIVIDADE.NRATIVIDADE = FCM_TAREFA.NRATIVIDADE
                 WHERE FCM_TAREFA.NRTAREFA IN ({$parametro})
                   AND FCM_TAGSTAREFA.DSTAGSTAREFA in (SELECT DSTAGSTAREFA
                                                         FROM FCM_TAGSTAREFA
                                                        WHERE NRTAREFA IN ({$parametro}))
                  GROUP BY FCM_TAGSTAREFA.NRTAGSTAREFA, FCM_TAGSTAREFA.DSTAGSTAREFA, FCM_CRITERIOTAREFA.NRCRITERIOTAREFA, 
                       FCM_CRITERIOTAREFA.DSCRITERIOTAREFA, FCM_TAREFA.NRTAREFA, FCM_TAREFA.NMTAREFA, 
                       FCM_ATIVIDADE.NRATIVIDADE, FCM_ATIVIDADE.NMATIVIDADE
                  ORDER BY FCM_ATIVIDADE.NRATIVIDADE,  FCM_TAREFA.NRTAREFA, FCM_TAGSTAREFA.NRTAGSTAREFA, FCM_CRITERIOTAREFA.NRCRITERIOTAREFA";
                  
        $std = $this->connection->prepare($sql);
        $std->execute();
        return $std->fetchAll();
    }

    public function detalhesCheckist($param) {
        $sql = "SELECT FCM_CHECKLIST.NRTIPOLOCALCLI, FCM_CHECKLIST.NMCHECKLIST, FCM_CHECKLIST.DSCHECKLIST, FCM_ATIVIDADECHK.NRATIVIDADE, FCM_TAREFACHK.NRTAREFA,
                       FCM_TAGSCHKTAREFA.NRTAGSTAREFA, FCM_CRITERIOTAREFACHK.NRCRITERIOTAREFA, NVL(FCM_TAGSTAREFA.DSTAGSTAREFA, ' ') AS DSTAGSTAREFA
                  FROM FCM_CHECKLIST
                  LEFT JOIN FCM_ATIVIDADECHK
                    ON FCM_CHECKLIST.NRCHECKLIST = FCM_ATIVIDADECHK.NRCHECKLIST
                  LEFT JOIN FCM_TAREFACHK
                    ON FCM_ATIVIDADECHK.NRATIVIDADECHK = FCM_TAREFACHK.NRATIVIDADECHK
                  LEFT JOIN FCM_TAGSCHKTAREFA
                    ON FCM_TAREFACHK.NRTAREFACHK = FCM_TAGSCHKTAREFA.NRTAREFACHK
                  LEFT JOIN FCM_RELCRITERIOTAGTAREFACHK
                    ON FCM_TAGSCHKTAREFA.NRTAGSCHKTAREFA = FCM_RELCRITERIOTAGTAREFACHK.NRTAGSCHKTAREFA
                  LEFT JOIN FCM_CRITERIOTAREFACHK
                    ON FCM_RELCRITERIOTAGTAREFACHK.NRCRITERIOTAREFACHK = FCM_CRITERIOTAREFACHK.NRCRITERIOTAREFACHK
                  LEFT JOIN FCM_TAGSTAREFA
                    ON FCM_TAGSCHKTAREFA.NRTAGSTAREFA = FCM_TAGSTAREFA.NRTAGSTAREFA
                 WHERE FCM_CHECKLIST.NRCHECKLIST = :NRCHECKLIST";
                  
        $std = $this->connection->prepare($sql);
        $std->execute($param);
        return $std->fetchAll();
    }

    public function deleteDadosDeCriterio($param) {
        $sql = "DELETE FROM FCM_RELCRITERIOTAGTAREFACHK
                 WHERE NRTAGSCHKTAREFA IN (SELECT NRTAGSCHKTAREFA FROM FCM_TAGSCHKTAREFA
                  JOIN FCM_TAREFACHK
                    ON FCM_TAREFACHK.NRTAREFACHK = FCM_TAGSCHKTAREFA.NRTAREFACHK
                  JOIN FCM_ATIVIDADECHK
                    ON FCM_ATIVIDADECHK.NRATIVIDADECHK = FCM_TAREFACHK.NRATIVIDADECHK
                 WHERE FCM_ATIVIDADECHK.NRCHECKLIST = :NRCHECKLIST)";
                  
        $std = $this->connection->prepare($sql);
        $std->execute($param);
        
        $sql = "DELETE FROM FCM_CRITERIOTAREFACHK
                 WHERE NRTAREFACHK IN (SELECT FCM_TAGSCHKTAREFA.NRTAREFACHK 
                                                 FROM FCM_TAGSCHKTAREFA
                                                 JOIN FCM_TAREFACHK
                                                   ON FCM_TAGSCHKTAREFA.NRTAREFACHK = FCM_TAREFACHK.NRTAREFACHK
                                                 JOIN FCM_ATIVIDADECHK
                                                   ON FCM_ATIVIDADECHK.NRATIVIDADECHK = FCM_TAREFACHK.NRATIVIDADECHK
                                                WHERE FCM_ATIVIDADECHK.NRCHECKLIST = :NRCHECKLIST)";
                  
        $std = $this->connection->prepare($sql);
        $std->execute($param);
        
        $sql = "DELETE FROM FCM_TAGSCHKTAREFA
                 WHERE NRTAREFACHK IN (SELECT NRTAREFACHK FROM FCM_TAREFACHK
                  JOIN FCM_ATIVIDADECHK
                    ON FCM_ATIVIDADECHK.NRATIVIDADECHK = FCM_TAREFACHK.NRATIVIDADECHK
                 WHERE FCM_ATIVIDADECHK.NRCHECKLIST = :NRCHECKLIST)";
                  
        $std = $this->connection->prepare($sql);
        $std->execute($param);
        
        $sql = "DELETE FROM FCM_TAREFACHK
                 WHERE NRATIVIDADECHK IN (SELECT NRATIVIDADECHK
                  FROM FCM_ATIVIDADECHK
                 WHERE NRCHECKLIST = :NRCHECKLIST)";
                  
        $std = $this->connection->prepare($sql);
        $std->execute($param);
        
        $sql = "DELETE FROM FCM_ATIVIDADECHK
                 WHERE NRCHECKLIST = :NRCHECKLIST";
                  
        $std = $this->connection->prepare($sql);
        $std->execute($param);
    }
    
    public function atualizarChecklist($parametroNovoChecklist) {
        $sql = "UPDATE FCM_CHECKLIST 
                SET NMCHECKLIST = :NMCHECKLIST,
                DSCHECKLIST = :DSCHECKLIST,
                NRTIPOLOCALCLI = :NRTIPOLOCALCLI
                WHERE NRCHECKLIST = :NRCHECKLIST";
                
        $std =  $this->connection->prepare($sql);
        $std->execute($parametroNovoChecklist);
    }
    public function quantidadeDeTarefas($param) {
        $sql = "SELECT count(*) AS NRDETAREFAS
                  FROM FCM_TAREFA
                 WHERE NRATIVIDADE = :NRATIVIDADE";
                
        $std =  $this->connection->prepare($sql);
        $std->execute($param);
        return $std->fetchAll();
    }
    
    public function deletarTarefasESubjacentes($param) {
        $sql = "DELETE FROM FCM_CRITERIOTAREFA
                 WHERE NRTAREFA = :NRTAREFA";
                
        $std =  $this->connection->prepare($sql);
        $std->execute($param);
        
        $sql = "DELETE FROM FCM_TAGSTAREFA
                 WHERE NRTAREFA = :NRTAREFA";
                
        $std =  $this->connection->prepare($sql);
        $std->execute($param);
        
        $sql = "DELETE FROM FCM_TAREFA
                 WHERE NRTAREFA = :NRTAREFA";
                
        $std =  $this->connection->prepare($sql);
        $std->execute($param);
    }
    
    public function deletarAtividade($param) {
        $sql = "DELETE FROM FCM_ATIVIDADE
                 WHERE NRATIVIDADE = :NRATIVIDADE";
                 
        $std =  $this->connection->prepare($sql);
        $std->execute($param);
    }
    
    
}
?>