/* eslint-disable no-console */
/* eslint-disable */
import {
  Metadata, Http,
  IDictionary, Router,
  IEventParam,
} from '@zeedhi/core';
import {
  Select, Switch, DialogService,
  Container, Form, TextInput,
  Button, Text, Col, AlertService,
} from '@zeedhi/common';
import ColorPicker from '@/components/colorPicker/ZdColorPicker';
import { getRouteParams } from '../router';

export class LocalAtendimentoController {
  public dataValue: string = '';

  public editable = false;
  
  public locationChildren: IDictionary = []; // Array onde vão ser salvos os filhos e filhos dos filhos do agrupamento completo
  
  public locationsList: IDictionary= []; // Lista global com todos os locais
  
  public prohibitedId: number = 0; // Representa o id do agrupamento completo que não pode ser incluido no tree grid
  
  public treeGridLocations(locationId: number, locationName:string, locationParent: number, locationCode: number, locationType: string, locationTypeId: string) {
    return {
      value: locationId,
      parentId: (locationParent === null) ? '' : locationParent,
      name: locationName,
      code: locationCode,
      type: locationType,
      typeId: locationTypeId
    };
  }

  // Lista para cada campo da tela
  public localDataList: IDictionary = {
    SelectCliente: [],
    sectorLocalAt: [],
    group: [],
    employee: [],
    checkListLocalAt: [],
  };

  // Inicializar os meus dados
  public inicializarDados() {
    Promise.all([this.setSector(), this.setCheckList(), this.setCliente()]).then(() => {
      this.getToUpdate();
    });
    // this.setGroup();
    // this.setEmployee();
  }

  // Setar dados dentro da minha lista
  public setDados(nome: string, code:number) {
    return {
      name: nome,
      value: code,
    };
  }

  // Seta dados especificamente para o campo "Tipo de Local"
  public setDadosLocal(nome: string, code:number, dif:string) {
    return {
      name: nome,
      value: code,
      addInfo: dif,
    };
  }

  // Habilita o campo checklist
  public validaCheckListPadrao({ component }: IEventParam<Select>) {
    const checkListObject = Metadata.getInstance<Select>('checkListLocalAt');
    const valid = component.datasource.data.filter((infos) => (component.value === infos.value));
    const localParentAtObject = Metadata.getInstance<Select>('localParentLocalAt');

    if (valid[0].addInfo === '3') {
      checkListObject.disabled = false;
    } else {
      checkListObject.disabled = true;
      checkListObject.setValue('');
    }
    if (valid[0].addInfo === '1') {
      localParentAtObject.disabled = true;
      localParentAtObject.setValue('');
      localParentAtObject.removeValidation('required');
      this.organizeCampos(true);
    } else {
      localParentAtObject.disabled = false;
      localParentAtObject.addValidation('required');
      this.organizeCampos(false);
      // colorPickerObject.value.hexa = '';
    }
  }

  // Organiza os campos para exibir ou esconder o ZdColorPicker
  public organizeCampos(condicao: boolean) {
    const ColComSelects = Metadata.getInstance<Col>('ColComSelects');
    const ColComColorPicker = Metadata.getInstance<Col>('ColComColorPicker');
    const formPai = Metadata.getInstance<Form>('inputFormLocalAt');
    if (condicao) {
      ColComSelects.cols = '8';
      ColComColorPicker.isVisible = true;
      formPai.children[0].grid!.cols = '4';
      formPai.children[1].grid!.cols = '4';
      formPai.children[2].grid!.cols = '4';
      formPai.children[3].grid!.cols = '4';
      formPai.children[4].grid!.cols = '4';
      formPai.children[5].grid!.cols = '4';
      formPai.children[6].grid!.cols = '4';
      formPai.cssStyle = {
        'border-right': '1px solid #d8d7d3',
        'padding-right': '2em',
      };
    } else {
      ColComSelects.cols = '12';
      ColComColorPicker.isVisible = false;
      formPai.children[0].grid!.cols = '3';
      formPai.children[1].grid!.cols = '3';
      formPai.children[2].grid!.cols = '3';
      formPai.children[3].grid!.cols = '3';
      formPai.children[4].grid!.cols = '3';
      formPai.children[5].grid!.cols = '3';
      formPai.children[6].grid!.cols = '3';
      formPai.cssStyle = {};
    }
  }

  // Torna visível o field group Tarefa Programada (Não está sendo usado)
  public isVisibleContainer() {
    const containerObject = Metadata.getInstance<Container>('task_container');
    const checkListObject = Metadata.getInstance<Select>('checkListLocalAt');
    const switchObject = Metadata.getInstance<Switch>('switch');

    if (checkListObject.value && switchObject.value) {
      containerObject.isVisible = true;
    } else {
      containerObject.isVisible = false;
    }
  }

  public consoleLog({ component }: {component: ColorPicker}) {
    console.log(component);
    const titulo = Metadata.getInstance<Text>('titulo');
    titulo.text = 'text';
  }

  // Form validation
  public createClick() {
    const formObject = Metadata.getInstance<Form>('inputFormLocalAt');
    const formValidate1 = formObject.validate();

    if (formValidate1) {
      this.insertLocalInfos();
      Router.replace('/gerenciarLocais');
    }
  }

  // Setando valores do campo "Cliente"
  public setCliente() {
    return new Promise((resolve, reject) => {
      try {
        Http.get('/getClient').then((response: IDictionary) => {
          response.data.dataset.clientes.forEach((dados: IDictionary) => {
            this.localDataList.SelectCliente.push({ name: dados.NMFANTCLIE, value: dados.CDCLIENTE });
          });
          resolve();
        });
      } catch (error) {
        reject(error);
      }
    });
  }

  public getCliente({ component }:any) {
    Http.get('/getClient').then((response: IDictionary) => {
      component.datasource.updateData(response.data.dataset.clientes);
    });
  }

  private tipoDeLocal: any = [];

  // Setando valores do campo "Tipo de Local"
  public async setLocal({ component }:any) {
    Http.get('/getLocalType').then((response: IDictionary) => {
      component.datasource.updateData(response.data.dataset.options.filter((elemento: any) => elemento.IDTIPOLOCALCLI === "1"));
      this.tipoDeLocal = response.data.dataset.options;
    });
  }

  // Setando valores do campo [LocalParent]
  public async setLocalParent({ component }:any) {
    await Http.get('/getLocalParent').then((response: IDictionary) => {
      component.datasource.updateData(response.data.dataset.options);
    });
  }

  public changeLocal({ component }:any) {
    const selectTipoLocal = Metadata.getInstance<Select>('localTypeLocalAt');
    selectTipoLocal.setValue([]);
    if (component.value === null){
      selectTipoLocal.datasource.updateData(this.tipoDeLocal.filter((elemento: any) => elemento.IDTIPOLOCALCLI === "1"));
    } else if (component.value.IDTIPOLOCALCLI === "1") {
      selectTipoLocal.datasource.updateData(this.tipoDeLocal.filter((elemento: any) => elemento.IDTIPOLOCALCLI === "2"));
    } else if (component.value.IDTIPOLOCALCLI === "2") {
      selectTipoLocal.datasource.updateData(this.tipoDeLocal.filter((elemento: any) => elemento.IDTIPOLOCALCLI === "3"));
    }
  }

  // Setando valores do campo "Setor"
  public setSector() {
    return new Promise((resolve, reject) => {
      try {
        Http.get('/getSector').then((response: IDictionary) => {
          response.data.dataset.options.forEach((dados: IDictionary) => {
            this.localDataList.sectorLocalAt.push(this.setDados(dados.NMSETOR, dados.NRSETOR));
          });
          resolve();
        });
      } catch (error) {
        reject(error);
      }
    });
  }

  // Setando valores do campo "Check List Padrão
  public setCheckList() {
    return new Promise((resolve, reject) => {
      try {
        Http.get('/getCheckListLocalAtend').then((response: IDictionary) => {
          response.data.dataset.options.forEach((dados: IDictionary) => {
            this.localDataList.checkListLocalAt.push(this.setDados(dados.NMCHECKLIST, dados.NRCHECKLIST));
          });
          resolve();
        });
      } catch (error) {
        reject(error);
      }
    });
  }

  // Salvando no data do component para exibir na tela
  public findDados({ component }:any) {
    component.datasource.updateData(this.localDataList[component.name]);
  }

  public async getColorLocal(): Promise<string> {
    const localPai: Select = Metadata.getInstance<Select>('localParentLocalAt').value.NRLOCALCLIENTE;
    let colorValue: string = '';
    if (localPai) {
      const response: IDictionary = await Http.get(`/Locals?NRLOCALCLIENTE=${localPai}`);
      const local = response.data.dataset.Locals[0];
      colorValue = local.DSCORIDLOCAL;
    } else {
      colorValue = Metadata.getInstance<ColorPicker>('colorPicker').value.toString();
    }
    return colorValue;
  }

  /*  --------- Inserts ----------  */

  public insertLocalInfos() {
    const params: IDictionary = {
      NMLOCALCLIENTE: Metadata.getInstance<TextInput>('nameLocalAt').value,
      CDCLIENTE: Metadata.getInstance<Select>('SelectCliente').value,
      NRTIPOLOCALCLI: Metadata.getInstance<Select>('localTypeLocalAt').value,
      NRLOCALCLIENTEPAI: Metadata.getInstance<Select>('localParentLocalAt').value.NRLOCALCLIENTE,
      NRCHECKLISTPADR: Metadata.getInstance<Select>('checkListLocalAt').value,
      NRSETOR: Metadata.getInstance<Select>('sectorLocalAt').value,
      DSICONELOCAL: null,
      DSQRCODE: null,
      NRORG: 20,
      CDOPERINCLUSAO: '000000004280',
      NRORGINCLUSAO: 20,
      DTULTATU: null,
      CDOPERULTATU: null,
      NRORGULTATU: null,
      NRGRUPOLOCAL: null,
      DSCODIGOLOCALCLI: Metadata.getInstance<TextInput>('codeLocalAt').value,
      // DSCORIDLOCAL: colorLocalPai,
    };
    this.getColorLocal()
      .then((colorLocalPai: string) => {
        params.DSCORIDLOCAL = colorLocalPai;
        Http.post('/insertLocalAt', { params })
          .then((response: IDictionary) => {
            if (response.data.dataset.options.message === 'Inserido com sucesso') {
              AlertService.show({
                name: 'insertionConcluded',
                text: 'Local inserido com sucesso',
                color: 'success',
                top: true,
                left: false,
              });
            } else {
              DialogService.show({
                name: 'insertionFailed',
                type: 'error',
                title: 'Erro!',
                text: 'Não foi possível inserir um novo local.',
              });
            }
          })
          .catch((err) => {
            AlertService.show({
              name: 'basic-alert',
              text: err,
              color: 'error',
              top: true,
              left: false,
            });
          });
      })
      .catch((err) => {
        AlertService.show({
          name: 'basic-alert',
          text: err,
          color: 'error',
          top: true,
          left: false,
        });
        throw err;
      });
  }

  // Inserir tarefa programada (Não está sendo usado)
  // public insertTaskInfos() {
  //   const params = {
  //     NRCHECKLISTAGEND: Metadata.getInstance<Select>('checkListLocalAt').value,
  //     NRFUNCIONARIO: Metadata.getInstance<Select>('employee').value,
  //     DSOBSTAREFAAGEND: null,
  //     NRORG: 20,
  //     CDOPERINCLUSAO: '000000004280',
  //     NRORGINCLUSAO: 20,
  //     DTULTATU: null,
  //     CDOPERULTATU: null,
  //     NRORGULTATU: null,
  //   };

  //   const test = {
  //     teste: [],
  //   };

  //   test.teste.push(params);
  //   // Http.post('/insertTask', { params })
  // }

  /*  --------- Updates ----------  */

  public getToUpdate() {
    const routeParams = getRouteParams();
    const { nr } = routeParams;

    const params = {
      NRLOCALCLIENTE: nr,
    };

    Http.post('/getLocalAtToUpdate', { params }).then((response) => {
      response.data.dataset.options.forEach((dados: IDictionary) => {
        Metadata.getInstance<Text>('nrLocalAt').text = dados.NRLOCALCLIENTE;
        Metadata.getInstance<TextInput>('nameLocalAt').value = dados.NMLOCALCLIENTE;
        Metadata.getInstance<Select>('SelectCliente').value = dados.CDCLIENTE;
        Metadata.getInstance<Select>('localTypeLocalAt').setValue(Number(dados.NRTIPOLOCALCLI));
        Metadata.getInstance<Select>('localParentLocalAt').setValue(dados.NRLOCALCLIENTEPAI);
        Metadata.getInstance<Select>('sectorLocalAt').setValue(dados.NRSETOR);
        Metadata.getInstance<Select>('checkListLocalAt').setValue(dados.NRCHECKLISTPADR);
        Metadata.getInstance<TextInput>('codeLocalAt').value = dados.DSCODIGOLOCALCLI;
        Metadata.getInstance<ColorPicker>('colorPicker').value = dados.DSCORIDLOCAL;
        this.setUpdate();
      });
    });
  }

  // Muda o label do botao criar e chama atribui o evento de click update para ele
  public setUpdate() {
    const buttonObject = Metadata.getInstance<Button>('saveButtonLocalAt');
    buttonObject.label = 'Salvar';
    buttonObject.events = {
      click: () => this.finalUpdate(),
    };
  }

  // Atualiza os dados do Local de Atendimento
  public finalUpdate() {
    const params: IDictionary = {
      NRLOCALCLIENTE: Metadata.getInstance<Text>('nrLocalAt').text,
      NMLOCALCLIENTE: Metadata.getInstance<TextInput>('nameLocalAt').value,
      CDCLIENTE: Metadata.getInstance<Select>('SelectCliente').value,
      NRTIPOLOCALCLI: Metadata.getInstance<Select>('localTypeLocalAt').value,
      NRLOCALCLIENTEPAI: Metadata.getInstance<Select>('localParentLocalAt').value.NRLOCALCLIENTE,
      NRCHECKLISTPADR: Metadata.getInstance<Select>('checkListLocalAt').value,
      NRSETOR: Metadata.getInstance<Select>('sectorLocalAt').value,
      DSCODIGOLOCALCLI: Metadata.getInstance<TextInput>('codeLocalAt').value,
      // DSCORIDLOCAL: Metadata.getInstance<ColorPicker>('colorPicker').value,
    };
    Router.replace('/gerenciarLocais');
    this.getColorLocal()
      .then((colorLocalPai: string) => {
        params.DSCORIDLOCAL = colorLocalPai;
        Http.post('/updateLocalAt', { params }).then((response: IDictionary) => {
          if (response.data.dataset.options.message === 'Editado com sucesso') {
            AlertService.show({
              name: 'updateConcluded',
              text: 'Local editado com sucesso',
              color: 'success',
              top: true,
              left: false,
            });
          } else {
            DialogService.show({
              name: 'updateFailed',
              type: 'error',
              title: 'Erro!',
              text: 'Não foi possível editar o local.',
            });
          }
        });
      })
  }

  // Abre a tela com o local superior já preenchido
  public setParentLocal(parentId: number) {
    Router.replace('/localAtendimento/null');
    setTimeout(() => {
      Metadata.getInstance<Select>('localParentLocalAt').setValue(parentId);
    }, 1000);
  }
  
  // Chamado pelo arquivo de Gerencial locais - Busca os locais filhos de cada local do tipo agrupamento completo (complete grouping - CG)
  public async mountLocationChildrenArray(locationId: number) {
    this.locationChildren = [];
    this.prohibitedId = locationId; 
    await this.getAllLocations();

    this.gatherLocationChildren(locationId);
    return this.locationChildren; // retorna o array montado só com os filhos e filhos dos filhos do agrupamento completo X
  }
  
  // Salva num array os filhos a partir do local de agrupamento completo
  public gatherLocationChildren(locationId: number) {
    this.locationsList.forEach((location: any) => {
      if (locationId === location.parentId) {
        this.locationChildren.push({
          name: location.name,
          value: location.value,
          parentId: (location.parentId === this.prohibitedId) ? '' : location.parentId,
          locationType: location.type,
          locationTypeId: location.typeId,
        });
        this.gatherLocationChildren(location.value);
      }
    });
  }
  
  // Busca todos os locais existentes e salva num array
  public async getAllLocations() {
    this.locationsList = [];
  
    await Http.get('/getLocals').then((response: IDictionary) => {
      response.data.dataset.info.forEach((database: IDictionary) => {
        this.locationsList.push(this.treeGridLocations(database.NRLOCALCLIENTE, database.NMLOCALCLIENTE, database.NRLOCALCLIENTEPAI, database.DSCODIGOLOCALCLI, database.NMTIPOLOCALCLI, database.IDTIPOLOCALCLI));
      });
    });
  }
}
